Description

Currently only administrators can copy projects, which is not ideal because Project Managers should be able to create, edit and copy

projects but not have full access to everything else. The copying is important, because certain projects are used as templates and

are only ever copied to speed everything up.

Attached is a patch which removes the :copy from the require_admin before_filter and instead adds its own method to determine

copy access. This method essentially checks if the user can edit the project, and if so grants access to copy. The patch also adds a

button to copy a project to the contextual links area when viewing a project if the current user can edit the project.

Button:

 new-copy-button.png 

I realize this patch is incomplete (I don't use translatable labels for the button and I should ideally create a new permission instead of

using "edit") but this is as far as my current knowledge can take me. In the mean time I hope this patch is a good jumping off point for

either other developers or core developers to use for further improvements.

Related issues:

Related to Redmine - Feature #4687: Add copy project permission New 2010-01-29

History

#1 - 2017-02-22 14:34 - Nick Vanpraet

Note: this patch is for Redmine version 3.3.2-stable

#2 - 2017-02-22 21:11 - Mischa The Evil

- Tracker changed from Feature to Patch

- Subject changed from As non-administrator I'd like to be able to copy certain projects to Allow non-administrator users to copy certain projects

#3 - 2017-02-22 21:14 - Mischa The Evil

- Related to Feature #4687: Add copy project permission added

#4 - 2018-04-25 12:41 - Anders Thomsen

Duped by #18835

#5 - 2019-06-22 01:04 - Charlie Savage

- File project_copy.patch added

Updated patch for Redmine 4.0.3

Files

patch.separate_copy_permission.patch 2.34 KB 2017-02-22 Nick Vanpraet

new-copy-button.png 15.7 KB 2017-02-22 Nick Vanpraet

project_copy.patch 2.23 KB 2019-06-21 Charlie Savage
